TableMapper::SqlStatementOutboundMapper Class Reference

provides an outbound data mapper to a Table with SqlUtil select hash as a asource More...

Inheritance diagram for TableMapper::SqlStatementOutboundMapper:
[legend]

## Public Member Functions

| constructor (SqlUtil::Table source, *hash sh, hash mapv, *hash opts)
| builds the object based on an optional hash providing field mappings, data constraints, and optionally custom mapping logic More...
| constructor (SqlUtil::AbstractTable source, *hash sh, hash mapv, *hash opts)
| builds the object based on an optional hash providing field mappings, data constraints, and optionally custom mapping logic More...
Qore::SQL::AbstractDatasource | getDatasource ()
| returns the AbstractDatasource object associated with this object
SqlUtil::AbstractTable | getTable ()
| returns the underlying SqlUtil::AbstractTable object More...
string | getTableName ()
| returns the table name More...
| initStatement ()
| initializes the internal statement object
Public Member Functions inherited from TableMapper::AbstractSqlStatementOutboundMapper
| commit ()
| commits the transaction and frees the Qore::SQL::AbstractDatasource transaction thread resource
| constructor (hash mapv, *hash opts)
| builds the object based on an optional hash providing field mappings, data constraints, and optionally custom mapping logic More...
*hash | getData ()
| Retrieve mapped data as a hash of lists. More...
*list | getDataRows ()
| Retrieve mapped data as a list of hashes. More...
Qore::SQL::SQLStatement | getRowIterator ()
| returns a row iterator for the underlying SQL statement for this object More...
SqlStatementMapperIterator | iterator ()
| Returns an SqlStatementMapperIterator based on the current object. More...
hash | optionKeys ()
| returns a list of valid constructor options for this class (can be overridden in subclasses) More...
| rollback ()
| rolls the transaction back and frees the Qore::SQL::AbstractDatasource transaction thread resource

## Static Public Member Functions

static *hash | getStaticInputRecord (AbstractTable table, *hash select_hash, *reference< string > sql, *hash input)
| returns a description of the input record based on Qore::SQL::SQLStatement::describe()

## Private Member Functions

| initOptions (reference< hash > opts)
| initializes options

## Additional Inherited Members

Public Attributes inherited from TableMapper::AbstractSqlStatementOutboundMapper
const | OptionDefaults
| default option values
const | OptionKeys
| option keys for this object

## Detailed Description

provides an outbound data mapper to a Table with SqlUtil select hash as a asource

## Member Function Documentation

## constructor() [1/2]

TableMapper::SqlStatementOutboundMapper::constructor | ( | SqlUtil::Table | source,
|  | *hash | sh,
|  | hash | mapv,
|  | *hash | opts
| ) |  |

builds the object based on an optional hash providing field mappings, data constraints, and optionally custom mapping logic

The source statement is also scanned using Qore::SQL::SQLStatement and column definitions are used to update the source record specification.

Parameters

  source | the source table object. A `sh` select hash is applied to this table
  sh | a SqlUtil select hash
  mapv | a optional hash providing overrides for the default 1:1 input to output field mappings; each hash key is the name in lower case of the output column in the target table; each value is either True (meaning no translations are done; the data is copied 1:1) or a hash describing the mapping; see Mapper Specification Format for detailed documentation for this option

  opts

  an optional hash of options for the mapper; see Mapper Options for a description of valid mapper options plus the following options specific to this object:
  - `"select_block"`: for size of the batch returned from TableMapper::AbstarctSqlStatementOutboundMapper::getData() or AbstarctSqlStatementOutboundMapper::getDataRows()

Exceptions

  MAP-ERROR |

## constructor() [2/2]

TableMapper::SqlStatementOutboundMapper::constructor | ( | SqlUtil::AbstractTable | source,
|  | *hash | sh,
|  | hash | mapv,
|  | *hash | opts
| ) |  |

builds the object based on an optional hash providing field mappings, data constraints, and optionally custom mapping logic

The source statement is also scanned using Qore::SQL::SQLStatement and column definitions are used to update the source record specification.

Parameters

  source | the source table object. A `sh` select hash is applied to this table
  sh | a SqlUtil select hash
  mapv | a optional hash providing overrides for the default 1:1 input to output field mappings; each hash key is the name in lower case of the output column in the target table; each value is either True (meaning no translations are done; the data is copied 1:1) or a hash describing the mapping; see Mapper Specification Format for detailed documentation for this option

  opts

  an optional hash of options for the mapper; see Mapper Options for a description of valid mapper options plus the following options specific to this object:
  - `"select_block"`: for size of the batch returned from TableMapper::AbstarctSqlStatementOutboundMapper::getData() or AbstarctSqlStatementOutboundMapper::getDataRows()

Exceptions

  MAP-ERROR |

## getTable()

SqlUtil::AbstractTable TableMapper::SqlStatementOutboundMapper::getTable | ( |  | ) |

returns the underlying SqlUtil::AbstractTable object

Returns
  SqlUtil::AbstractTable provided in constructor

## getTableName()

string TableMapper::SqlStatementOutboundMapper::getTableName | ( |  | ) |

returns the table name

Returns
  string with main table name